# Multitasking OS for azzuP. Waugh. This is to Linux as 9wm is to fvwm2.
# -azz
#
! .pc *ffff
! .a *fffe
! i.a @fffe
! .b *fffd
! i.b @fffd
! .c *fffc
! .intpc *fffb
! .intcount *fffa
! .intvec *fff9
! .sp *fff8
! console ?0
! tasklist #e000

# Initialise the multitasking.
# Number of cycles a task gets each time round.
! _numcycles #20
 
# Address 0.
mv #&startos .pc

# Address 3, the base of the OS routines.
: oscall
mv #&getc .pc
mv #&putc .pc
mv #&halt .pc

: getc
mv console .a
mv .a .c
mv?z #&getc .pc
do r

: putc
mv .b console
do r

: halt
do h

# start the os

: startos
# init the stack pointer
mv #8000 .sp
# init the task list
mv #&tasklist *&current_task
mv #&introutine .intvec
# This enables interrupts, and therefore MT.
mv _numcycles .intcount
# And become the first task.
mv #&shell .pc

# The ao shell.
: shell
mv #'a console
mv #'o console
mv #'/ console
# call getc
mv #3 .a
do c
mv .a console
mv #0d console
mv .a *&cmd
mv #'h .b
do -
mv .a .c
mv?z #9 .pc
mv #'? console
mv #0d console
mv #&shell .pc

var cmd


# Second task
: task2
mv #e200 .sp
: loop2
mv console *&chin
mv *&chin .c
mv?z #&nextch .pc
mv *&chin .a
# #71 is lowercase q
mv #71 .b
do -
mv .a .c
mv?z #&dohalt .pc
mv *&chin console
: nextch
mv #&loop2 .pc

# Third task - print stream of Bs
: task3
mv #e100 .sp
: loop3
mv #42 console
mv #&loop3 .pc

: dohalt
do h

var chin


# The business end of the multitasking. This could be improved size-wise
# but, for now, not made more efficient.
: introutine
# Stash the registers.
mv .a *&stash_a
mv .b *&stash_b
mv .c *&stash_c
mv .intpc *&stash_pc
mv .sp *&stash_sp
# Move them into the right place.
mv #1 .b
mv *&stash_pc @&current_task
mv *&current_task .a
do +
mv .a *&current_task
mv *&stash_a @&current_task
mv *&current_task .a
do +
mv .a *&current_task
mv *&stash_b @&current_task
mv *&current_task .a
do +
mv .a *&current_task
mv *&stash_c @&current_task
mv *&current_task .a
do +
mv .a *&current_task
mv *&stash_sp @&current_task
mv *&current_task .a
do +
mv .a *&current_task
# current_task should now point at the next task struct. Check to
# see if it's 0.
mv @&current_task .c
mv?o #&notendoflist .pc
mv #&tasklist *&current_task
: notendoflist
# now restore the registers and return into the next task...
mv #1 .b
mv @&current_task *&stash_pc
mv *&current_task .a
do +
mv .a *&current_task
mv @&current_task *&stash_a
mv *&current_task .a
do +
mv .a *&current_task
mv @&current_task *&stash_b
mv *&current_task .a
do +
mv .a *&current_task
mv @&current_task *&stash_c
mv *&current_task .a
do +
mv .a *&current_task
mv @&current_task *&stash_sp
mv *&current_task .a
mv #4 .b
do -
mv .a *&current_task
# and move the registers out of stash, resetting the count on the way
mv *&stash_a .a
mv *&stash_b .b
mv *&stash_c .c
mv _numcycles .intcount
mv *&stash_sp .sp
mv *&stash_pc .pc
#
var stash_a
var stash_b
var stash_c
var stash_pc
var stash_sp
var current_task
#
# Task list (must be at end of code!).
: tasklist
lit #&shell
lit #0
lit #0
lit #0
lit #0
# lit #&task2
# lit #0
# lit #0
# lit #0
# lit #0
# The next lit #0 means end of tasks. (task ptr = 0)
lit #0
