#!/usr/bin/python
""" Assembler for azzuP2.
Absolutely horrible. A real kludge.

Use as: asm.py source
Reads source.s, writes source.

Accepts:
mv[?<cond>] <from> <to>
do <thing>
lit <value> [...]
var <name>			(like ": name \ lit #00" )
: label

<from>, <to>: #<lit> *<mem> @<ind> ?<io>
<mem>, <ind>, <lit>, <io>: hex-number &label 'char
<thing>: + - ~ & | h
<cond>: z[ero] [n]o[n-zero] p[os] n[eg] d[on't]

Not immensely clever. :)
"""

import os
import sys
import string

def main():
	try:
		infile = open(sys.argv[1] + '.s', 'r')
	except:
		print 'Cannot open input file.'
		sys.exit(20)
	
	print 'Pass 1'
	pc = 0
	labels = {}
	preproc = {}
	for x in infile.readlines():
		if len(string.split(x)) == 0:
			x = '#'
		cmd = string.split(x)[0]
		if cmd[0] == 'm':
			pc = pc + 3
		if cmd == 'do':
			pc = pc + 1 
		if cmd == 'var':
			labels[string.split(x)[1]] = pc
			pc = pc + 1
		if cmd == 'lit':
			pc = pc + len(string.split(x))-1 
		if cmd == ':':
			labels[string.split(x)[1]] = pc
		if cmd == '!':
			preproc[string.split(x)[1]] = string.split(x)[2]
	infile.seek(0, 0)

	try:
		outfile = open(sys.argv[1], 'w')
	except:
		print 'Cannot open output file.'
		sys.exit(20)

	condnum = {'a' : 0, 'd' : 0x10, 'z' : 0x20, 'o' : 0x30, 'p' : 0x40, 'n' : 0x50}

	print 'Pass 2'
	for x in infile.readlines():
		if len(string.split(x)) == 0:
			x = '#'
		splut = string.split(x)
		for dipsy in range(len(splut)):
			if preproc.has_key(splut[dipsy]):
				splut[dipsy] = preproc[splut[dipsy]]
		cmd = splut[0]
		if len(sys.argv)>2:
			print splut
		if cmd[0] == 'm':
			src = splut[1]
			dest = splut[2]
			out = typenumb(src) + typenuma(dest)
			if len(cmd)>2 and cmd[2] == '?':
				out = out + condnum[cmd[3]]
			s = ref(labels, src)
			d = ref(labels, dest)
			outfile.write(chr(0) + chr(out)	+ chr(s/256) + chr(s%256) + chr(d/256) + chr(d%256))
		if cmd == 'do':
			ops = { '0' : 0, '+' : 1, '-' : 2, '~' : 3, '&' : 4, '|' : 5, 'h' : 0x3f, 'c' : 6, 'r' : 7 }
			op = splut[1][0]
			outfile.write(chr(0) + chr(0x80 + ops[op]))
		if cmd == 'lit':
			for value in splut[1:]:
				r = ref(labels, value)
				outfile.write(chr(r/256) + chr(r%256))
		if cmd == 'var':
			outfile.write(chr(0) + chr(0))	
	infile.close()
	outfile.close()	

def typenuma(x):
	if x[0] == '#':
		return 0
	if x[0] == '*':
		return 1
	if x[0] == '@':
		return 2
	if x[0] == '?':
		return 3

def typenumb(x):
	return typenuma(x)<<int(2)

def ref(l, x):
	if x[1]=='&':
		return l[x[2:]] 
	if x[1]=='\'':
		return ord(x[2])
	else:
		return eval('0x' + x[1:])	

main()
sys.exit(0)

