/* simulator for azzuP1 - a real hack by azz */

#include <stdio.h>
#include <string.h>

#define PC mem[255]
#define DEBUG debug

unsigned char mem[256];
int debug=0;

int main(int argc, char **argv) {
   FILE *f;
   long length;
   unsigned char x=0;
   if (argc>2) if (argv[2][0]=='d') debug=1;
   if ((f = fopen(argv[1], "r")) != NULL) {
      while (!feof(f)) mem[x++] = fgetc(f);
      fclose(f);
      simulate();
   } else {
      printf("Couldn't open memory image\n");
   };
};

int simulate() {
   int running=1;
   unsigned char reg[3], cond, optype, regnum, k;
   
   for (cond=0;cond<3;cond++) reg[cond]=0;
   
   PC = 0;
   while (running == 1) {
      cond = mem[PC]&0x30;
      optype = mem[PC]&0x0F;
      if ((mem[PC]&0x40) > 0) {regnum = 1;} else {regnum = 0;};
      if (DEBUG == 1) { 
	 printf("pc:%02x ins:%02x a:%02x b:%02x r:%02x f:%02x it:%02x ot:%02x reg:%02x cond:%02x ", PC, mem[PC], reg[0], reg[1], reg[2], reg[3], mem[PC]&0xC0, optype, regnum, cond);
	 for (k=0xF8; k<0xFF; k++) printf("%02x",mem[k]);
	 printf("\n");
      };
      switch(mem[PC]&0xC0) {
       case 0x00:
       case 0x40:
	 switch(optype) {
	  case 0x00:
	    reg[regnum] = mem[++PC];
	    break;
	  case 0x01:
	    reg[regnum] = mem[mem[++PC]];
	    break;
	  case 0x02:
	    reg[regnum] = mem[mem[mem[++PC]]];
	    break;
	  default:
	    printf("unknown optype\n");
	    break;
	 };
	 break;
       case 0x80:
	 if ((cond==0x00) || ((cond==0x10)&&(reg[3]!=0)) || ((cond==0x20)&&(reg[3]<128))
	     || ((cond==0x30)&&(reg[3]>127))) {
	    if (DEBUG == 1) printf("execute\n");
	    switch(optype) {
	     case 0x01: k=PC+1; PC++; mem[mem[k]] = reg[2]; break;
	     case 0x02: k=PC+1; PC++; mem[mem[mem[k]]] = reg[2]; break;
	     default: printf("unknown optype\n"); break;
	    };
	 } else {
	    PC++;
	 };
	 reg[3]=reg[2];
	 break;
       case 0xC0:
	 if (DEBUG == 1) printf("do=%02x\n", mem[PC]&0x0F);
	 switch(mem[PC]&0x3F) {
	  case 0x00: reg[2]=0; break;
	  case 0x01: reg[2]=reg[0]; break;
	  case 0x02: reg[2]=reg[0]+reg[1]; break;
	  case 0x03: reg[2]=reg[0]-reg[1]; break;
	  case 0x04: reg[2]=!reg[0]; break;
	  case 0x05: reg[2]=reg[0]&reg[1]; break;
	  case 0x06: reg[2]=reg[0]|reg[1]; break;
	  case 0x3D: putchar(reg[0]); break;
	  case 0x3E: reg[2]=getchar(); break;
	  case 0x3F: running=0; break;
	  default:
	    if (DEBUG == 1) printf("unknown do\n");
	    break;
	 };
	 break;
      };
      PC++;
   };
};
